/*------------------------------------------------------------------------------
 * @file     EventRecorder.h
 * @brief    Event Recorder Header File
 * @version  1.0.0
 * @date     22. January 2016
 *----------------------------------------------------------------------------*/
 
/* Copyright (c) 2016 ARM LIMITED
 
   All rights reserved.
   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are met:
   - Redistributions of source code must retain the above copyright
     notice, this list of conditions and the following disclaimer.
   - Redistributions in binary form must reproduce the above copyright
     notice, this list of conditions and the following disclaimer in the
     documentation and/or other materials provided with the distribution.
   - Neither the name of ARM nor the names of its contributors may be used
     to endorse or promote products derived from this software without
     specific prior written permission.
   *
   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
   AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
   ARE DISCLAIMED. IN NO EVENT SHALL COPYRIGHT HOLDERS AND CONTRIBUTORS BE
   LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
   CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
   SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
   INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
   CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
   ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
   POSSIBILITY OF SUCH DAMAGE.
   ---------------------------------------------------------------------------*/

#ifndef __EVENT_RECORDER_H
#define __EVENT_RECORDER_H

#include <stdint.h>

#ifdef __cplusplus
extern "C" {
#endif

extern uint32_t Event_Initialize (void);

extern uint32_t Event_TimeStampInit (void);
extern uint32_t Event_TimeStampGet  (void);

extern uint32_t Event_Record0 (uint16_t id);
extern uint32_t Event_Record1 (uint16_t id, uint32_t par1);
extern uint32_t Event_Record2 (uint16_t id, uint32_t par1, uint32_t par2);
extern uint32_t Event_Record3 (uint16_t id, uint32_t par1, uint32_t par2, uint32_t par3);
extern uint32_t Event_Record4 (uint16_t id, uint32_t par1, uint32_t par2, uint32_t par3, uint32_t par4);
extern uint32_t Event_Record5 (uint16_t id, uint32_t par1, uint32_t par2, uint32_t par3, uint32_t par4, uint32_t par5);
extern uint32_t Event_Record6 (uint16_t id, uint32_t par1, uint32_t par2, uint32_t par3, uint32_t par4, uint32_t par5, uint32_t par6);
extern uint32_t Event_Record7 (uint16_t id, uint32_t par1, uint32_t par2, uint32_t par3, uint32_t par4, uint32_t par5, uint32_t par6, uint32_t par7);
extern uint32_t Event_Record8 (uint16_t id, uint32_t par1, uint32_t par2, uint32_t par3, uint32_t par4, uint32_t par5, uint32_t par6, uint32_t par7, uint32_t par8);

#ifdef __cplusplus
}
#endif

#endif /* __EVENT_RECORDER_H */
